#include <hmg.ch>
#include <GraphPlus.ch>

Function Main
   private aGraphObjects := {}
   define window chart at 0, 0 width 890 height 800 title 'GraphPlus Demo' main
      define tab tab1 at 10, 10 width 860 height 650
         define page 'HMG Dashboard'
            DEFINE WINDOW gallery ;
			      ROW 30 ;
			      COL 10 ;
			      WIDTH 820 ;
			      HEIGHT 610 ;
			      VIRTUALHEIGHT 4000 ;
			      WINDOWTYPE PANEL
               define image image1
                  row 30
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 2
               end image               
               define image image2
                  row 30
                  col 410
                  width 400
                  height 300
                  onclick chart.tab1.value := 3
               end image
               define image image3
                  row 340
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 4
               end image
               define image image4
                  row 340
                  col 410
                  width 400
                  height 300
                  onclick chart.tab1.value := 5
               end image
               define image image5
                  row 650
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 6
               end image
               define image image6
                  row 650
                  col 410
                  width 400
                  height 300
                  onclick chart.tab1.value := 7
               end image
               define image image7
                  row 960
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 8
               end image
               define image image8
                  row 960
                  col 410
                  width 400
                  height 75
                  onclick chart.tab1.value := 9
               end image
               define image image9
                  row 1270
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 10
               end image
               define image image10
                  row 1270
                  col 410
                  width 400
                  height 300
                  onclick chart.tab1.value := 11
               end image
               define image image11
                  row 1580
                  col 10
                  width 400
                  height 300
                  onclick chart.tab1.value := 12
               end image
            end window   
         end page
         define page 'Column'
            define image chart1
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Points'
            define image chart2
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Line'
            define image chart3
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Pie'
            define image chart4
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Bars'
            define image chart5
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Bar'
            define image chart6
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Funnel'
            define image chart7
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Grid Data'
            define image chart8
               row 30
               col 30
               width 800
               height 400
            end image
            define grid data
               row 440
               col 30
               width 400
               height 180
               headers { 'Period', 'Sales', 'Profit' }
               widths { 100, 120, 120 }
               justify { 0, 1, 1 }
               items { { 'January', '15000', '2500' }, { 'February', '14000', '2800' },;
                        { 'March', '10000', '-2000' },;               
                        { 'April', '16000', '3500' },;
                        { 'May', '15800', '3000' },;
                        { 'June', '16400', '4000' },;
                        { 'July', '15300', '2800' }}
               value 1                        
            end grid  
         end page            
         define page 'Stacked Column'
            define image chart9
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Stacked Bar'
            define image chart10
               row 30
               col 30
               width 800
               height 600
            end image
         end page
         define page 'Area'
            define image chart11
               row 30
               col 30
               width 800
               height 600
            end image
         end page
      end tab
      define button savefiles
         row 720
         col 10
         width 80
         caption 'Save All'
         action saveallfiles()
      end button   
      define button switch
         row 720
         col 110
         width 180
         caption 'Switch Rows and Columns'
         action switchrows()
      end button   
      define checkbutton legends
         row 690
         col 300
         width 120
         caption 'Show Legends'
         onchange drawcharts()
      end checkbutton   
      define checkbutton horizontalgrid
         row 690
         col 430
         width 120
         caption 'Horizontal Grid'
         onchange drawcharts()
      end checkbutton   
      define checkbutton verticalgrid
         row 690
         col 560
         width 120
         caption 'Vertical Grid'
         onchange drawcharts()
      end checkbutton   
      define checkbutton legendsbottom
         row 690
         col 690
         width 120
         caption 'Legends in Bottom'
         onchange drawcharts()
      end checkbutton   
      define checkbutton datalabels
         row 720
         col 300
         width 120
         caption 'Data Labels'
         onchange drawcharts()
      end checkbutton   
      define checkbutton categories
         row 720
         col 430
         width 120
         caption 'Categories'
         onchange drawcharts()
      end checkbutton   
      define checkbutton values
         row 720
         col 560
         width 120
         caption 'Values'
         onchange drawcharts()
      end checkbutton   
   end window
   initcharts()
   StopControlEventProcedure ( 'legends', 'chart', .t. )
   StopControlEventProcedure ( 'horizontalgrid', 'chart', .t. )
   StopControlEventProcedure ( 'verticalgrid', 'chart', .t. )
   StopControlEventProcedure ( 'legendsbottom', 'chart', .t. )
   StopControlEventProcedure ( 'datalabels', 'chart', .t. )
   StopControlEventProcedure ( 'categories', 'chart', .t. )
   StopControlEventProcedure ( 'values', 'chart', .t. )
   chart.legends.value := .t.
   chart.horizontalgrid.value := .t.
   chart.verticalgrid.value := .t.
   chart.legendsbottom.value := .t.
   chart.datalabels.value := .f.
   chart.categories.value := .t.
   chart.values.value := .t.
   StopControlEventProcedure ( 'legends', 'chart', .f. )
   StopControlEventProcedure ( 'horizontalgrid', 'chart', .f. )
   StopControlEventProcedure ( 'verticalgrid', 'chart', .f. )
   StopControlEventProcedure ( 'legendsbottom', 'chart', .f. )
   StopControlEventProcedure ( 'datalabels', 'chart', .f. )
   StopControlEventProcedure ( 'categories', 'chart', .f. )
   StopControlEventProcedure ( 'values', 'chart', .f. )
   drawcharts()
   chart.center
   chart.activate
Return

function initcharts
   local oObj := nil
   asize( aGraphObjects, 0 )
   // hmgcolumn
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Column Chart'
      :Picture := '99,999.99'  
      :BarGapRatio := -0.4     
   endwith
   aadd( aGraphObjects, oObj )
   // hmgpoints
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Points Chart'
      :Picture := '99,999.99' 
      :GraphType := GT_POINTS      
   endwith
   // hmgline
   aadd( aGraphObjects, oObj )
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { { 14280,  20420,  12870,  25347,   7640 },;
                           {  8350,  10315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Line Chart'
      :Picture := '99,999.99' 
      :GraphType := GT_LINE      
   endwith
   aadd( aGraphObjects, oObj )
   // pie
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { 13876405, 13404512, 3397445, 2697803, 2245456, 2166422, 2128265, 1860504, 1314459, 1257990 }
      :Legends   := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :Title := 'Population Top 10 Countries'
      :GraphType := GT_PIE      
   endwith
   aadd( aGraphObjects, oObj )

   //bars   
   oObj := GraphPlus():new()
   with object oObj
      :GraphData := { { 13876405, 13404512, 3397445, 2697803, 2245456, 2166422, 2128265, 1860504, 1314459, 1257990 },;
      { 16642318, 3049704, 22675271, 1158783, 1491772, 296000, 514049, 352908, 1710734, 1192480 } }
      :Categories := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :Legends := { "Population in Hundreds", "GDP in Million $" }
      :Title := 'World Population - Top 10'
      :BarGapRatio := 0
      :BarGapWidthRatio := 0.1      
      :GraphType := GT_BAR
   endwith
   aadd( aGraphObjects, oObj )
   
   // hmgbar
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { 1387640576, 1340451200, 339744544, 269780352, 224545616, 216642256, 212826576 , 186050400, 131445920, 125799016 }
      :Categories := { "China", "India", "United States of America", "Indonesia", "Brazil", "Pakistan", "Nigeria", "Bangladesh", "Russia", "Mexico" }
      :Title := 'World Population - Top 10'
      :BarGapRatio := 0  
      :BarGapWidthRatio := 0.1      
      :LegendFont := array font 'Arial' size 10
      :GraphType := GT_BAR
   endwith
   aadd( aGraphObjects, oObj )   
   // funnel
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { 8000, 6000, 4500, 2000, 1200, 900 }
      :Categories := { "Awareness", "Interest", "Consideration", "Intent", "Evaluation", "Purchases" }
      :Title := 'Sales Funnel'
      :BarGapRatio := 0  
      :BarGapWidthRatio := 0.1      
      :GraphType := GT_FUNNEL
   endwith
   aadd( aGraphObjects, oObj )
   // grid data
   oObj := GraphPlus():new()
   with object oObj
      :GridData( 'chart', 'data' )
      :Width := 800
      :Height := 400
      :SwitchRowstoColumns()
      :Title := 'Data from Grid!'
   endwith   
   aadd( aGraphObjects, oObj )
   // stacked column
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { { 14280,  -20420,  12870,  25347,   7640 },;
                           {  8350,  20315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Stacked Column'
      :Picture := '99,999'  
      :BarGapRatio := -0.4     
      :GraphType := GT_STACKEDCOLUMN
   endwith
   aadd( aGraphObjects, oObj )

   // stacked bar
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { { 14280,  -20420,  12870,  25347,   7640 },;
                           {  8350,  20315,  15870,   5347,  12340 },;
                           { 12345,  -8945,  10560,  15600,  17610 } }
      :Legends   := { "Serie 1", "Serie 2", "Serie 3"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Stacked Bar'
      :Picture := '99,999'  
      :BarGapRatio := -0.4     
      :GraphType := GT_STACKEDBAR
   endwith
   aadd( aGraphObjects, oObj )
   // Area
   oObj := GraphPlus():New()
   with object oObj
      :GraphData := { {  800,  1000,  1100,  1040, 980 },;
                      {  650,   780,  1300,   840, 700 },;
                      {  150,   220,  -200,   200, 280 } }
      :Legends   := { "Sales", "Cost", "Profit"}
      :Categories := { "January",  "February",  "March",  "April",  "May" }       
      :Title := 'Area Chart'
      :Picture := '99,999'  
      :BarGapRatio := -0.4     
      :GraphType := GT_AREA
   endwith
   aadd( aGraphObjects, oObj )
return nil   

function drawcharts
   local nTotalTabs := hmg_len( aGraphObjects )
   local oObj := nil
   local cControl := '', cThumbnail := '' 
   local nImageWidth := 0, nImageHeight := 0
   local i := 0
   for i := 1 to nTotalTabs
      oObj := aGraphObjects[ i ]
      cControl := 'chart' + alltrim( str( i, 2, 0 ) )
      cThumbnail := 'image' + alltrim( str( i, 2, 0 ) )
      nImageHeight := if( i <> 8, 600, 400 ) // for grid data
      nImageWidth := 800 
      with object oObj
         :Width := nImageWidth
         :Height := nImageHeight
         :ShowLegends := chart.legends.value
         :ShowLabels := chart.datalabels.value
         :ShowCategories := chart.categories.value
         :ShowValues := chart.values.value
         :LegendPos := if( chart.legendsbottom.value, LEGEND_ON_BOTTOM, LEGEND_ON_RIGHT )
         :ShowHGrid := chart.horizontalgrid.value
         :ShowVGrid := chart.verticalgrid.value
         :LegendFont := create array font 'Arial' size 12 Bold .f.
         :TitleFont := create array font 'Arial' size 16 Bold .t.
         :Draw()
         setproperty( 'chart', cControl, 'HBITMAP', :Bitmap )
         setproperty( 'gallery', cThumbnail, 'HBITMAP', :Bitmap( 400, if( i <> 8, 300, 150 ) ) )
      endwith    
   next i   
return nil

function switchrows
   local nTabNo := chart.tab1.value
   local oObj := nil
   local cControl := 'chart'
   if .not. ( nTabNo == 4 .or. nTabNo == 7 ) // pie and funnel chart
      oObj := aGraphObjects[ nTabNo ]
      cControl := cControl + alltrim( str( nTabNo, 2, 0 ) )
      if oObj <> nil
         with object oObj
            :SwitchRowstoColumns()
            :Draw()
            setproperty( 'Chart', cControl, 'HBITMAP', :Bitmap() )
         endwith
      endif   
   endif   
return nil   

function saveallfiles
   for i := 1 to hmg_len( aGraphObjects )
      oObj := aGraphObjects[ i ]
      oObj:save( 'GraphPlus' + padl( i, 2, '0' ) + '.png' )
   next i            
return nil